Issue 1241 rollback doesn't look beyond a tag

Title rollback doesn't look beyond a tag
Priority bug Status needs-reproduction
Milestone Resolved in
Superseder Nosy List dmitry.kurochkin, drewp, galbolle, kowey, thorkilnaur
Assigned To

Created on 2008-11-25.06:33:10 by drewp, last changed 2010-12-18.09:44:46 by kowey.

msg6744 (view) Author: drewp Date: 2008-11-25.06:35:15
I ran 'darcs rollback file1' and got 'No patches selected!'. Then I used
darcsweb to get the old patch I had in mind, and I manually made an inverse
patch to commit. I thought this is what rollback was going to do for me, in
which case I don't know why it reported no patches. My guess is that the patches
I wanted to undo were before a tag, although I have not verified this.

darcs 2.1.0

http://bugs.darcs.net/issue158 and http://bugs.darcs.net/issue159 may be related.
msg6745 (view) Author: kowey Date: 2008-11-25.09:27:49
On Tue, Nov 25, 2008 at 06:35:18 -0000, Drew Perttula wrote:
> My guess is that the patches I wanted to undo were before a tag,
> although I have not verified this.

That sounds right to me.  I notice that a lot of darcs commands
naturally 'stop' at tags, which may be more a feature than a bug (I
would be happier if somebody could do research into this issue and
determine if this behaviour really is desirable or not in this case).
The workaround so far is to darcs get --tag, darcs obliterate the
tag (in your clone), and do the rollback there.  I agree that this is
rather icky from a UI standpoint.
msg8234 (view) Author: kowey Date: 2009-08-18.09:35:33
I think it makes sense to think of (the new) rollback as being different from
(say) obliterate and to expect it to be able to go beyond tags.

I think we need a regression test for this 
msg10607 (view) Author: kowey Date: 2010-04-01.12:43:40
As I understand it, we're waiting for patch185 to be applied (which
would open the door to rollback looking beyond tags).  Then we could
think more carefully about what should happen beyond tags, eg. if
rollback should behave differently, if all commands should look beyond
tags, etc.

Taking the liberty of making Florent nosy as he's working on that
(making people nosy is sometimes a source of complaints, but I don't
know a better way of playing switchboard)
msg12177 (view) Author: kowey Date: 2010-08-14.16:30:49
Patch185 has since been applied, so now we should open a discussion on 
darcs-users on whether commands should look past tags or not and what the 
implications would be.
msg13379 (view) Author: kowey Date: 2010-12-18.09:39:17
I just noticed this inconsistency:
  darcs rollback file1 (and darcs obliterate --match 'touch file1')
do not look beyond the last tag, BUT
  darcs rollback --match 'touch file1'
does.  Just noting it for future reference.
msg13380 (view) Author: kowey Date: 2010-12-18.09:44:45
Note also that the behaviour of rollback --match 'touch file' (in other 
words rollback matcher-based-selection looking past tags) working exists 
since darcs-2.3.1, which would seem to disprove my hypothesis that this 
was introduced in Florent's patch158

Maybe this is why it's been so hard to get a handle on things.  
Inconsistent behaviour.
Date User Action Args
2008-11-25 06:33:10drewpcreate
2008-11-25 06:35:18drewpsetstatus: unread -> unknown
nosy: + drewp
messages: + msg6744
2008-11-25 09:27:52koweysetnosy: kowey, dagit, simon, drewp, thorkilnaur, dmitry.kurochkin
messages: + msg6745
2009-08-10 23:52:15adminsetnosy: - dagit
2009-08-18 09:35:35koweysetstatus: unknown -> needs-reproduction
nosy: kowey, simon, drewp, thorkilnaur, dmitry.kurochkin
messages: + msg8234
2009-08-25 17:35:07adminsetnosy: + darcs-devel, - simon
2009-08-27 14:26:23adminsetnosy: kowey, darcs-devel, drewp, thorkilnaur, dmitry.kurochkin
2009-09-30 21:23:33koweylinkissue1628 superseder
2010-04-01 12:43:41koweysetstatus: needs-reproduction -> waiting-for
nosy: + galbolle
messages: + msg10607
2010-08-14 16:30:50koweysetstatus: waiting-for -> needs-reproduction
messages: + msg12177
2010-12-18 09:17:50koweylinkpatch458 issues
2010-12-18 09:39:18koweysetnosy: - darcs-devel
messages: + msg13379
2010-12-18 09:44:46koweysetmessages: + msg13380